<?php

/** Impersonate iTunes and download a file.  When the version changes, it may
    also be necessary to change the version string in here.  I use \r\n escapes
    because I develop on Windows and sometimes end up with weird conversions
    when I transfer to Mac/Linux.
    
    The headers passed in were observed in a transmission of iTunes, except
    the HTTP version which is because I don't want to deal with 1.1.
 */
function download_itunes($url, $dump=false) {
	//caches, and returns
	$r=raw_download(
	"ax.phobos.apple.com.edgesuite.net",
	"GET {$url} HTTP/1.0\r\nReferer: http://ax.phobos.apple.com.edgesuite.net/WebObjects/MZStore.woa/wa/storeFront\r\nAccept-Language: rn-us, en;q=0.50\r\nUser-Agent: iTunes/4.1 (Windows; U; Microsoft Windows XP Professional Service Pack 1 (Build 2600)) DPI/96\r\nCookie: countryVerified=1\r\nAccept-Encoding: gzip, x-aes-cbc\r\nHost: ax.phobos.apple.com.edgesuite.net\r\n\r\n",
	false);
	if($dump) {
		$f=fopen("rawdownload_dump.txt", "w");
		fputs($f, $r);
		fclose($f);
	}
	return $r;
}

/** Handle a raw download via socket.  This would be likely implemented via
    LWP in Perl.  This also handles some rudimentary caching because I didn't
    want to hammer the server during testing.
    
    If filename is specified, then the data will be saved to it instead of
    being returned.  When you specify a filename, the return value is @true
    when it succeeds.  When no filename is specified, it returns whatever
    the server returned for the data portion.  It dies if there is some
    agregious error, because I use this for testing things often.
    
    It's also a bit chatty.  This is on purpose, so you can see some feedback
    if the server is being slow.  The basic feedback is suppressed if not
    running as CLI.
 */
function raw_download($host, $query, $filename=false) {
	if(PHP_SAPI == "cli") echo "-> Beginning Download...\n";
	if($filename==false) {
		$cfn="cache/".md5($query);
		if(file_exists($cfn))
			return file_get_contents($cfn);
		$cf=fopen($cfn,"w");
	}
	
	if(PHP_SAPI == "cli") echo "   File is not in cache.\n";
	
	$fp = fsockopen($host, 80);
	$found_end_of_headers=false;
	if($filename !== false) {
		echo "   Opening $filename\n";
		if(!$f=fopen($filename,"w"))
			die("Cannot open $filename for writing");
	}
	
	fwrite($fp, $query);
	$found_end_of_headers=false;
	$r="";
	
	while ($tmp = fread($fp, 8192)) {
		if($found_end_of_headers) {
			//Dump to the file (or variable, not suggested for large files!)
			if($filename != false) {
				fputs($f, $tmp);
				echo ".";
			} else {
				$r.=$tmp;
			}
			if(PHP_SAPI == "cli") {
				echo ".";
				flush(); //flush console so we get all the .'s
			}
		} else if(!$found_end_of_headers && strpos($tmp, "\r\n\r\n") !== false) {
			//yay, end of the headers, so dump the part _after_ the \n\n and grab the
			//content length for future use
			$pos=strpos($tmp, "\r\n\r\n") + 4;
			$headers=substr($tmp,0,$pos);
			if($filename != false) {
				fputs($f, substr($tmp, $pos));
			} else {
				$r.=substr($tmp,$pos);
			}
			$found_end_of_headers=true;
		} else {
			echo "Weirdness, didn't find header.  Chunk follows:\n";
			echo $tmp;
			die();
		}
	}
	if(PHP_SAPI == "cli") echo "\n";
	//only do this if we're returning data... I don't want to handle an inplace
	//gunzip at this point.  Note that we cache it uncompressed.
	if($filename == false) {
		if(strpos($headers, "Content-Encoding: gzip") !== false) {
			$r=gzinflate(substr($r,10));
		}
		fputs($cf, $r);
		fclose($cf);
		return $r;
	}
	return true;
}


?>
